@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S %0 %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/env perl
#line 15
use strict;
use warnings;
use utf8;

use FileHandle;
use File::Spec::Functions qw( :ALL );


my $temp_file = catfile( tmpdir(), 'tmp.dat' );

# ċA
# t@C̃tpXKv畁ʂ̍ċAŏȂ
sub shorten_path {
    my ( $parent, $dir, @dirs ) = @_ or die;
    my $curdir = catfile( $parent, $dir );


    # $dir Kv8.3`ɒ
    if( length $dir > 8 ) {

        # fBNgXg擾
        if( -f $curdir ) {
            # t@C
            # (𕪂ƃrgCdirĂяoȂ̂Œ)
            system( "dir /x $curdir > $temp_file" );

        } elsif( -d $curdir ) {
            # fBNg
            my $up = catfile( $curdir, '..' );
            system( "dir /x $up > $temp_file" );

        } else {
            # ̑(t@CƓ)
            system( "dir /x $curdir > $temp_file" );
        }

        my $FH = FileHandle->new( "< $temp_file" );
        # t@C̍so
        my @files = grep m#^\d{4}/\d{2}/\d{2}\s+\d{2}:\d{2}.*$dir#, <$FH>;
        die join "\n", @files   if( @files != 1 );

        $FH->close;

        my $fn = ( split /\s+/, $files[0] )[3];
        $curdir = catdir( $curdir, '..', $fn );
    }

    if( @dirs ) {
        shorten_path( $curdir, @dirs );
    } else {
        # I
        unlink $temp_file;
        $curdir;
    }
}
### FUNCTIONS ###


### MAIN ###

my $orig_dir = shift || '.';
$orig_dir = rel2abs( $orig_dir );

# system֐Ăяoтɋ󔒍s}Ă܂̂
my $NULL = FileHandle->new( '> ' . devnull() );
my $stdout = select( $NULL );   # nulɕύX

my $path = shorten_path( splitdir( $orig_dir ) );

select( $stdout );  # STDOUTɕύX
print $path;

$NULL->close;
### MAIN ###


__END__
vim: ft=perl
:endofperl
